package com.persagy.ztkedgeclouddatasecurity.netty;


import com.persagy.ztkedgeclouddatasecurity.entity.ChattingUser;
import com.persagy.ztkedgeclouddatasecurity.kafka.EdgeKafkaProducer;
import io.netty.channel.Channel;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.socket.SocketChannel;

import java.util.Map;
import java.util.Set;

public class MyChannelInitializer extends ChannelInitializer<SocketChannel> {

    private final EdgeKafkaProducer edgeKafkaProducer;
    private ChattingUser chattingUser;
    private Map<String, Set<Channel>> socketChannelMap;
    private String location;

    public MyChannelInitializer(ChattingUser chattingUser, EdgeKafkaProducer edgeKafkaProducer, Map<String, Set<Channel>> socketChannelMap,String location) {
        this.chattingUser = chattingUser;
        this.edgeKafkaProducer = edgeKafkaProducer;
        this.socketChannelMap = socketChannelMap;
        this.location = location;
    }

    @Override
    protected void initChannel(SocketChannel channel) {
//        channel.pipeline().addLast(new IdleStateHandler(60, 0, 0, TimeUnit.SECONDS));
        //对象传输处理[解码]
        channel.pipeline().addLast(new ObjDecoder());
        // 在管道中添加我们自己的接收数据实现方法
        channel.pipeline().addLast(new MsgHandler(chattingUser,edgeKafkaProducer,socketChannelMap,location));
        //对象传输处理[编码]
        channel.pipeline().addLast(new ObjEncoder());
    }

}
